/*#######################################################################################
AVR USART und ADC TEST PROGRAMM 

Copyright (C) 2005 Branko Golubovic

bane98@gmx.net

#######################################################################################*/

#include "main.h"
#include "uart.h"

volatile unsigned char RX0data;

//############################################################################
//Routine fr die Serielle Ausgabe
int uart_putchar (char c)
//############################################################################
{
	if (c == '\n')
		uart_putchar('\r');
	//Warten solange bis Zeichen gesendet wurde
	loop_until_bit_is_set(USR, UDRE);
	//Ausgabe des Zeichens
	UDR = c;
	return (0);
}


//############################################################################
// Receive complet Interrupt
SIGNAL (SIG_USART_RECV)
//############################################################################
{
 RX0data=UDR;
}


//############################################################################
//INstallation der Seriellen Schnittstelle
void UART_Init (void)
//############################################################################
{
	//Enable TXEN and RXEN im Register UCR TX/RX -Data Enable
	UCR=(1 << TXEN | 1 <<RXEN | 1 <<RXCIE);
	//Teiler wird gesetzt 
	UBRR=(SYSCLK / (BAUD_RATE * 16L) - 1);
	
	//ffnet einen Kanal fr printf (STDOUT)
	fdevopen (uart_putchar, NULL, 0);
}

